Given data about production and consumption of each community member in each discrete timestep, the following report gives insights about a hypothetical community structure with an optimally and fairly allocating market with a community battery accessible to all members.

In each timestep, the community market consists of suppliers, i.e. community members with more production than consumption in the given timestep and consumers (defined analogously). It is assumed that a member uses its self-produced energy to cover its own demand after each timestep and either sells the left-over energy on the market, becoming a supplier, or asking for the uncovered consumption on the market, becoming a consumer. If there's supply that cannot be sold on the market due to a lack of demand, this is assumed to be fed into the grid. If there's demand that cannot be covered by the market due to a lack of supply, this left-over demand is assumed to be covered by purchasing energy from the grid.

In each timestep, the market is computed as an optimal allocation from buyers to sellers, i.e. the trading volume is the minimum of demand and supply. The computed allocation is fair in each timestep, i.e. if the supply overpowers the demand by a factor of n in a given timestep, each supplier/seller can sell 1/n'th of its supply. The same guarantee holds for the demand side if it overpowers the supply side. The allocation itself is computed using a max-flow algorithm.

This means that if the demand covered by trades is 100%, the community is self-sufficient and can cover its entire consumption by self-production and by buying from other community members. This requires having a higher overall production than consumption, which is usually not the case. A better goal is to have the percentage of supply sold at 100%. This means that all of the overproduction stays within the community and a minimum must be consumed from the grid. With PV, this is also rare, since the overproduction of each community member is highly correlated with that of other members, so the market oftentimes has either very little demand (sunny) or very little supply (cloudy).

In such a case, a community battery helps improve upon the ratio of sold supply. Supply that cannot be sold due to a lack of demand on the community market can instead be used to charge the community battery. In times of high demand, members can discharge from the battery. The allocation of battery charging and discharging is solved in the same way as the market; After each timestep, the market is computed optimally first and the stronger market side can then either charge or discharge the battery. The amount of charge/discharge per community member is again computed in a fair manner, i.e. if the remaining battery capacity allows to cover 1/n'th of the remaining demand, each member may discharge 1/n'th of its demand.

The goal of a battery is to get the ratio of sold supply close to 1. In this report, we distinguish the ratio of sold supply and the ratio of supply put to the battery. Thus, ideally, we would get the sum of the two metrics to 1.
